## containerd-app 1.7.2

=== vendor/github.com/containerd/nri/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

PROTO_SOURCES = $(shell find . -name '*.proto' | grep -v /vendor/)
PROTO_GOFILES = $(patsubst %.proto,%.pb.go,$(PROTO_SOURCES))
PROTO_INCLUDE = -I$(PWD):/usr/local/include:/usr/include
PROTO_OPTIONS = --proto_path=. $(PROTO_INCLUDE) \
    --go_opt=paths=source_relative --go_out=. \
    --go-ttrpc_opt=paths=source_relative --go-ttrpc_out=.
PROTO_COMPILE = PATH=$(PATH):$(shell go env GOPATH)/bin; protoc $(PROTO_OPTIONS)

GO_CMD     := go
GO_BUILD   := $(GO_CMD) build
GO_INSTALL := $(GO_CMD) install
GO_TEST    := $(GO_CMD) test
GO_LINT    := golint -set_exit_status
GO_FMT     := gofmt
GO_VET     := $(GO_CMD) vet

GO_MODULES := $(shell $(GO_CMD) list ./...)

GOLANG_CILINT := golangci-lint
GINKGO        := ginkgo

BUILD_PATH    := $(shell pwd)/build
BIN_PATH      := $(BUILD_PATH)/bin
COVERAGE_PATH := $(BUILD_PATH)/coverage

PLUGINS := \
	$(BIN_PATH)/logger \
	$(BIN_PATH)/device-injector \
	$(BIN_PATH)/hook-injector \
	$(BIN_PATH)/differ \
	$(BIN_PATH)/v010-adapter \
	$(BIN_PATH)/template


ifneq ($(V),1)
  Q := @
endif

#
# top-level targets
#

all: build build-plugins

build: build-proto build-check

clean: clean-plugins

allclean: clean clean-cache

test: test-gopkgs

#
# build targets
#

build-proto: $(PROTO_GOFILES)

build-plugins: $(PLUGINS)

build-check:
	$(Q)$(GO_BUILD) -v $(GO_MODULES)

#
# clean targets
#

clean-plugins:
	$(Q)rm -f $(PLUGINS)

clean-cache:
	$(Q)$(GO_CMD) clean -cache -testcache

#
# plugins build targets
#

$(BIN_PATH)/logger: $(wildcard plugins/logger/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

$(BIN_PATH)/device-injector: $(wildcard plugins/device-injector/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

$(BIN_PATH)/hook-injector: $(wildcard plugins/hook-injector/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

$(BIN_PATH)/differ: $(wildcard plugins/differ/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

$(BIN_PATH)/v010-adapter: $(wildcard plugins/v010-adapter/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

$(BIN_PATH)/template: $(wildcard plugins/template/*.go)
	$(Q)echo "Building $@..."; \
	cd $(dir $<) && $(GO_BUILD) -o $@ .

#
# test targets
#

test-gopkgs: ginkgo-tests

ginkgo-tests:
	$(Q)$(GINKGO) run \
	    --race \
	    --trace \
	    --cover \
	    --covermode atomic \
	    --output-dir $(COVERAGE_PATH) \
	    --junit-report junit.xml \
	    --coverprofile coverprofile \
	    --succinct \
	    -r .; \
	$(GO_CMD) tool cover -html=$(COVERAGE_PATH)/coverprofile -o $(COVERAGE_PATH)/coverage.html

codecov: SHELL := $(shell which bash)
codecov:
	bash <(curl -s https://codecov.io/bash) -f $(COVERAGE_PATH)/coverprofile

#
# other validation targets
#

fmt format:
	$(Q)$(GO_FMT) -s -d -e .

lint:
	$(Q)$(GO_LINT) -set_exit_status ./...

vet:
	$(Q)$(GO_VET) ./...

golangci-lint:
	$(Q)$(GOLANG_CILINT) run

#
# proto generation targets
#

%.pb.go: %.proto
	$(Q)echo "Generating $@..."; \
	$(PROTO_COMPILE) $<

#
# targets for installing dependencies
#

install-protoc install-protobuf:
	$(Q)./scripts/install-protobuf && \

install-ttrpc-plugin:
	$(Q)$(GO_INSTALL) github.com/containerd/ttrpc/cmd/protoc-gen-go-ttrpc@74421d10189e8c118870d294c9f7f62db2d33ec1

install-protoc-dependencies:
	$(Q)$(GO_INSTALL) google.golang.org/protobuf/cmd/protoc-gen-go@v1.28.0

install-ginkgo:
	$(Q)$(GO_INSTALL) -mod=mod github.com/onsi/ginkgo/v2/ginkgo

=== debian/changelog ===
containerd-app (1.7.2-0ubuntu1~23.04.1) lunar; urgency=medium

  * Backport version from Mantic to Lunar (LP: #2023694, #2022390).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 29 Jun 2023 17:39:58 -0300

containerd-app (1.7.2-0ubuntu1) mantic; urgency=medium

  * Initial release. See LP #2022390.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 20 Jun 2023 16:20:38 -0300

=== debian/control ===
Source: containerd-app
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: Lucas Kanashiro <kanashiro@ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               go-md2man,
               golang-go,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libseccomp-dev,
               pkg-config
Standards-Version: 4.6.2
Homepage: https://containerd.io
Vcs-Git: https://github.com/canonical/containerd-app.git
Vcs-Browser: https://github.com/canonical/containerd-app

Package: containerd
Architecture: linux-any
Depends: runc, ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 19.03.13-0ubuntu4)
Built-Using: ${misc:Built-Using}
Description: daemon to control runC
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package contains the binaries.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

include /usr/share/dpkg/pkg-info.mk

export VERSION := $(DEB_VERSION_UPSTREAM)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

execute_before_dh_gencontrol:
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(TAGS)" \
		github.com/containerd/containerd/cmd/containerd \
		github.com/containerd/containerd/cmd/containerd-shim \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v1 \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
		github.com/containerd/containerd/cmd/containerd-stress \
		github.com/containerd/containerd/cmd/ctr \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'

override_dh_auto_configure:
	# copy pristine source for "/usr/share/gocode" to get into "golang-github-containerd-containerd-dev" before we muddy it with build artifacts, etc
	mkdir -p .pristine-source
	tar -c --exclude=debian --exclude=.pc --exclude=.pristine-source --exclude=vendor . | tar -xC .pristine-source
	# set up GOPATH symlink farm
	mkdir -p '$(OUR_GOPATH)/src/github.com/containerd'
	ln -sfT '$(CURDIR)' '$(OUR_GOPATH)/src/github.com/containerd/containerd'

override_dh_auto_build:
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' \
		&& make \
			LDFLAGS='' \
			VERSION='$(VERSION)' \
			REVISION='' \
			BUILDTAGS='$(TAGS)' \
		&& make man

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
endif
endif

override_dh_auto_install:
	make install DESTDIR='$(CURDIR)/debian/tmp' PREFIX='/usr'
	make install-man DESTDIR='$(CURDIR)/debian/tmp' PREFIX='/usr'
	mkdir -p debian/tmp/usr/share/gocode/src/github.com/containerd \
		&& mv .pristine-source debian/tmp/usr/share/gocode/src/github.com/containerd/containerd

execute_after_dh_installsystemd:
	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service

override_dh_dwz:
	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
	# dh_dwz --no-dwz-multifile also does not work :)

%:
	dh $@

## containerd-app 1.7.12

=== Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# Go command to use for build
GO ?= go
INSTALL ?= install

# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
# The files will be installed under `$(DESTDIR)/$(PREFIX)`.
# The convention of `DESTDIR` was changed in containerd v1.6.
PREFIX        ?= /usr/local
DATADIR       ?= $(PREFIX)/share
MANDIR        ?= $(DATADIR)/man

TEST_IMAGE_LIST ?=

# Used to populate variables in version package.
VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always)
REVISION=$(shell git rev-parse HEAD)$(shell if ! git diff --no-ext-diff --quiet --exit-code; then echo .m; fi)
PACKAGE=github.com/containerd/containerd
SHIM_CGO_ENABLED ?= 0

ifneq "$(strip $(shell command -v $(GO) 2>/dev/null))" ""
	GOOS ?= $(shell $(GO) env GOOS)
	GOARCH ?= $(shell $(GO) env GOARCH)
else
	ifeq ($(GOOS),)
		# approximate GOOS for the platform if we don't have Go and GOOS isn't
		# set. We leave GOARCH unset, so that may need to be fixed.
		ifeq ($(OS),Windows_NT)
			GOOS = windows
		else
			UNAME_S := $(shell uname -s)
			ifeq ($(UNAME_S),Linux)
				GOOS = linux
			endif
			ifeq ($(UNAME_S),Darwin)
				GOOS = darwin
			endif
			ifeq ($(UNAME_S),FreeBSD)
				GOOS = freebsd
			endif
		endif
	else
		GOOS ?= $$GOOS
		GOARCH ?= $$GOARCH
	endif
endif

ifndef GODEBUG
	EXTRA_LDFLAGS += -s -w
	DEBUG_GO_GCFLAGS :=
	DEBUG_TAGS :=
else
	DEBUG_GO_GCFLAGS := -gcflags=all="-N -l"
	DEBUG_TAGS := static_build
endif

WHALE = "🇩"
ONI = "👹"

RELEASE=containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
STATICRELEASE=containerd-static-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRIRELEASE=cri-containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRICNIRELEASE=cri-containerd-cni-$(VERSION:v%=%)-${GOOS}-${GOARCH}

PKG=github.com/containerd/containerd

# Project binaries.
COMMANDS=ctr containerd containerd-stress
MANPAGES=ctr.8 containerd.8 containerd-config.8 containerd-config.toml.5

ifdef BUILDTAGS
    GO_BUILDTAGS = ${BUILDTAGS}
endif
GO_BUILDTAGS ?=
GO_BUILDTAGS += urfave_cli_no_docs
GO_BUILDTAGS += ${DEBUG_TAGS}
ifneq ($(STATIC),)
	GO_BUILDTAGS += osusergo netgo static_build
endif
GO_TAGS=$(if $(GO_BUILDTAGS),-tags "$(strip $(GO_BUILDTAGS))",)

GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) $(EXTRA_LDFLAGS)
ifneq ($(STATIC),)
	GO_LDFLAGS += -extldflags "-static"
endif
GO_LDFLAGS+='

SHIM_GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) -extldflags "-static" $(EXTRA_LDFLAGS)'

# Project packages.
PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration)
API_PACKAGES=$(shell (cd api && $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration))
NON_API_PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration | grep -v "containerd/api")
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
	for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
		d="$$(dirname $$f)"; \
		[ "$$d" = "." ] && echo "${PKG}" && continue; \
		echo "${PKG}/$$d"; \
	done | sort -u) \
    )

ifdef SKIPTESTS
    PACKAGES:=$(filter-out ${SKIPTESTS},${PACKAGES})
    TEST_REQUIRES_ROOT_PACKAGES:=$(filter-out ${SKIPTESTS},${TEST_REQUIRES_ROOT_PACKAGES})
endif

#Replaces ":" (*nix), ";" (windows) with newline for easy parsing
GOPATHS=$(shell go env GOPATH | tr ":" "\n" | tr ";" "\n")

TESTFLAGS_RACE=
GO_BUILD_FLAGS=
# See Golang issue re: '-trimpath': https://github.com/golang/go/issues/13809
GO_GCFLAGS=$(shell				\
	set -- ${GOPATHS};			\
	echo "-gcflags=-trimpath=$${1}/src";	\
	)

BINARIES=$(addprefix bin/,$(COMMANDS))

#include platform specific makefile
-include Makefile.$(GOOS)

# Flags passed to `go test`
TESTFLAGS ?= $(TESTFLAGS_RACE) $(EXTRA_TESTFLAGS)
TESTFLAGS_PARALLEL ?= 8

# Use this to replace `go test` with, for instance, `gotestsum`
GOTEST ?= $(GO) test

OUTPUTDIR = $(join $(ROOTDIR), _output)
CRIDIR=$(OUTPUTDIR)/cri

.PHONY: clean all AUTHORS build binaries test integration generate protos check-protos coverage ci check help install uninstall vendor release static-release mandir install-man genman install-cri-deps cri-release cri-cni-release cri-integration install-deps bin/cri-integration.test
.DEFAULT: default

# Forcibly set the default goal to all, in case an include above brought in a rule definition.
.DEFAULT_GOAL := all

all: binaries

check: proto-fmt ## run all linters
	@echo "$(WHALE) $@"
	GOGC=75 golangci-lint run

ci: check binaries check-protos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

generate: protos
	@echo "$(WHALE) $@"
	@PATH="${ROOTDIR}/bin:${PATH}" $(GO) generate -x ${PACKAGES}

protos: bin/protoc-gen-go-fieldpath
	@echo "$(WHALE) $@"
	@find . -path ./vendor -prune -false -o -name '*.pb.go' | xargs rm
	$(eval TMPDIR := $(shell mktemp -d))
	@mv ${ROOTDIR}/vendor ${TMPDIR}
	@(cd ${ROOTDIR}/api && PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${API_PACKAGES})
	@(PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${NON_API_PACKAGES})
	@mv ${TMPDIR}/vendor ${ROOTDIR}
	@rm -rf ${TMPDIR}
	go-fix-acronym -w -a '(Id|Io|Uuid|Os)$$' $(shell find api/ runtime/ -name '*.pb.go')

check-protos: protos ## check if protobufs needs to be generated again
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files" && false))

check-api-descriptors: protos ## check that protobuf changes aren't present.
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.txt" | tee /dev/stderr)" || \
		((git diff $$(find . -name '*.pb.txt') | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files and check-in the generated descriptor file changes" && false))

proto-fmt: ## check format of proto files
	@echo "$(WHALE) $@"
	@test -z "$$(find . -path ./vendor -prune -o -path ./protobuf/google/rpc -prune -o -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "$(ONI) please indent proto files with tabs only" && false)

build: ## build the go packages
	@echo "$(WHALE) $@"
	@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} ${EXTRA_FLAGS} ${GO_LDFLAGS} ${PACKAGES}

test: ## run tests, except integration tests and tests that require root
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${PACKAGES}

root-test: ## run tests, except integration tests
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${TEST_REQUIRES_ROOT_PACKAGES} -test.root

integration: ## run integration tests
	@echo "$(WHALE) $@"
	@cd "${ROOTDIR}/integration/client" && $(GO) mod download && $(GOTEST) -v ${TESTFLAGS} -test.root -parallel ${TESTFLAGS_PARALLEL} .

# TODO integrate cri integration bucket with coverage
bin/cri-integration.test:
	@echo "$(WHALE) $@"
	@$(GO) test -c ./integration -o bin/cri-integration.test

cri-integration: binaries bin/cri-integration.test ## run cri integration tests (example: FOCUS=TestContainerListStats make cri-integration)
	@echo "$(WHALE) $@"
	@bash ./script/test/cri-integration.sh
	@rm -rf bin/cri-integration.test

# build runc shimv2 with failpoint control, only used by integration test
bin/containerd-shim-runc-fp-v1: integration/failpoint/cmd/containerd-shim-runc-fp-v1 FORCE
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./integration/failpoint/cmd/containerd-shim-runc-fp-v1

# build CNI bridge plugin wrapper with failpoint support, only used by integration test
bin/cni-bridge-fp: integration/failpoint/cmd/cni-bridge-fp FORCE
	@echo "$(WHALE) $@"
	@$(GO) build ${GO_BUILD_FLAGS} -o $@ ./integration/failpoint/cmd/cni-bridge-fp

# build runc-fp as runc wrapper to support failpoint, only used by integration test
bin/runc-fp: integration/failpoint/cmd/runc-fp FORCE
	@echo "$(WHALE) $@"
	@$(GO) build ${GO_BUILD_FLAGS} -o $@ ./integration/failpoint/cmd/runc-fp

benchmark: ## run benchmarks tests
	@echo "$(WHALE) $@"
	@$(GO) test ${TESTFLAGS} -bench . -run Benchmark -test.root

FORCE:

define BUILD_BINARY
@echo "$(WHALE) $@"
$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} -o $@ ${GO_LDFLAGS} ${GO_TAGS}  ./$<
endef

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	$(call BUILD_BINARY)

# gen-manpages must not have the urfave_cli_no_docs build-tag set
bin/gen-manpages: cmd/gen-manpages FORCE
	@echo "$(WHALE) $@"
	$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} -o $@ ${GO_LDFLAGS} $(subst urfave_cli_no_docs,,${GO_TAGS})  ./cmd/gen-manpages

bin/containerd-shim: cmd/containerd-shim FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim

bin/containerd-shim-runc-v1: cmd/containerd-shim-runc-v1 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v1

bin/containerd-shim-runc-v2: cmd/containerd-shim-runc-v2 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v2

binaries: $(BINARIES) ## build binaries
	@echo "$(WHALE) $@"

man: mandir $(addprefix man/,$(MANPAGES))
	@echo "$(WHALE) $@"

mandir:
	@mkdir -p man

# Kept for backwards compatibility
genman: man/containerd.8 man/ctr.8

man/containerd.8: bin/gen-manpages FORCE
	@echo "$(WHALE) $@"
	$< $(@F) $(@D)

man/ctr.8: bin/gen-manpages FORCE
	@echo "$(WHALE) $@"
	$< $(@F) $(@D)

man/%: docs/man/%.md FORCE
	@echo "$(WHALE) $@"
	go-md2man -in "$<" -out "$@"

define installmanpage
$(INSTALL) -d $(DESTDIR)$(MANDIR)/man$(2);
gzip -c $(1) >$(DESTDIR)$(MANDIR)/man$(2)/$(3).gz;
endef

install-man: man
	@echo "$(WHALE) $@"
	$(foreach manpage,$(addprefix man/,$(MANPAGES)), $(call installmanpage,$(manpage),$(subst .,,$(suffix $(manpage))),$(notdir $(manpage))))


define pack_release
	@rm -rf releases/$(1) releases/$(1).tar.gz
	@$(INSTALL) -d releases/$(1)/bin
	@$(INSTALL) $(BINARIES) releases/$(1)/bin
	@tar -czf releases/$(1).tar.gz -C releases/$(1) bin
	@rm -rf releases/$(1)
endef


releases/$(RELEASE).tar.gz: $(BINARIES)
	@echo "$(WHALE) $@"
	$(call pack_release,$(RELEASE))

release: releases/$(RELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(RELEASE).tar.gz >$(RELEASE).tar.gz.sha256sum

releases/$(STATICRELEASE).tar.gz:
ifeq ($(GOOS),linux)
	@make STATIC=1 $(BINARIES)
	@echo "$(WHALE) $@"
	$(call pack_release,$(STATICRELEASE))
else
	@echo "Skipping $(STATICRELEASE) for $(GOOS)"
endif

static-release: releases/$(STATICRELEASE).tar.gz
ifeq ($(GOOS),linux)
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(STATICRELEASE).tar.gz >$(STATICRELEASE).tar.gz.sha256sum
else
	@echo "Skipping releasing $(STATICRELEASE) for $(GOOS)"
endif

=== integration/images/volume-copy-up/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

all: build

PROJ=ghcr.io/containerd
VERSION=2.1
IMAGE=$(PROJ)/volume-copy-up:$(VERSION)
DOCKER_CERT_PATH ?= "$(HOME)/.docker"
REMOTE_DOCKER_URL ?=
DOCKER_REMOTE_ARGS ?=


ifneq ($(REMOTE_DOCKER_URL),)
	DOCKER_REMOTE_ARGS = --tlsverify --tlscacert "$(DOCKER_CERT_PATH)/ca.pem" \
		--tlscert "$(DOCKER_CERT_PATH)/cert.pem" \
		--tlskey "$(DOCKER_CERT_PATH)/key.pem" \
		-H "$(REMOTE_DOCKER_URL)"
endif

# Operating systems supported: linux, windows
OS ?= linux
# Architectures supported: amd64, arm64
ARCH ?= amd64
# OS Version for the Windows images: 1809, 20H2, ltsc2022
OSVERSION ?= 1809

# The output type could either be docker (local), or registry.
# If it is registry, it will also allow us to push the Windows images.
OUTPUT_TYPE ?= docker

ALL_OS = linux
ALL_ARCH.linux = amd64 arm64 ppc64le
ALL_OS_ARCH.linux = $(foreach arch, ${ALL_ARCH.linux}, linux-$(arch))

ifneq ($(REMOTE_DOCKER_URL),)
ALL_OS += windows
ALL_OSVERSIONS.windows := 1809 20H2 ltsc2022
ALL_OS_ARCH.windows = $(foreach osversion, ${ALL_OSVERSIONS.windows}, windows-amd64-${osversion})
BASE.windows := mcr.microsoft.com/windows/nanoserver
endif

BASE.linux.amd64 := busybox
BASE.linux.arm64 := arm64v8/busybox
BASE.linux.ppc64le := busybox
BASE.linux := ${BASE.linux.${ARCH}}
BASE := ${BASE.${OS}}

ALL_OS_ARCH = $(foreach os, $(ALL_OS), ${ALL_OS_ARCH.${os}})

configure-docker:
	gcloud auth configure-docker --quiet
	gcloud auth configure-docker --quiet $(shell echo $(PROJ) | cut -f 1 -d "/") || true

setup-buildx:
	docker buildx use img-builder || docker buildx create --name img-builder --use

build: setup-buildx build-local

push: configure-docker setup-buildx build-registry push-manifest

build-local: $(addprefix sub-container-docker-,$(ALL_OS_ARCH.linux))
build-registry: $(addprefix sub-container-registry-,$(ALL_OS_ARCH))

# split words on hyphen, access by 1-index
word-hyphen = $(word $2,$(subst -, ,$1))
sub-container-%:
	$(MAKE) OUTPUT_TYPE=$(call word-hyphen,$*,1) OS=$(call word-hyphen,$*,2) ARCH=$(call word-hyphen,$*,3) OSVERSION=$(call word-hyphen,$*,4) container

container: .container-${OS}-$(ARCH)

.container-linux-$(ARCH):
	docker buildx build --pull --output=type=${OUTPUT_TYPE} --platform ${OS}/${ARCH} \
		-t $(IMAGE)-${OS}-${ARCH} --build-arg BASE=${BASE} .

.container-windows-$(ARCH):
	docker $(DOCKER_REMOTE_ARGS) build --isolation=hyperv --no-cache --pull \
		-t $(IMAGE)-${OS}-${ARCH}-${OSVERSION} --build-arg BASE=${BASE}:${OSVERSION} \
		-f Dockerfile_windows .
	docker $(DOCKER_REMOTE_ARGS) push $(IMAGE)-${OS}-${ARCH}-${OSVERSION}

# For Windows images, we also need to include the "os.version" in the manifest list images,
# so the Windows node can pull the proper image it needs.
push-manifest:
	docker manifest create --amend $(IMAGE) $(shell echo $(ALL_OS_ARCH) | sed -e "s~[^ ]*~$(IMAGE)\-&~g")
	set -x; for arch in $(ALL_ARCH.linux); do docker manifest annotate --os linux --arch $${arch} ${IMAGE} ${IMAGE}-linux-$${arch}; done
	# we use awk to also trim the quotes around the OS version string.
	set -x; \
	for osversion in ${ALL_OSVERSIONS.windows}; do \
		full_version=`docker manifest inspect ${BASE.windows}:$${osversion} | grep "os.version" | head -n 1 | awk -F\" '{print $$4}'` || true; \
		docker manifest annotate --os windows --arch amd64 --os-version $${full_version} \
		${IMAGE} ${IMAGE}-windows-amd64-$${osversion}; \
	done
	docker manifest push --purge ${IMAGE}

.PHONY: configure-docker setup-buildx build push build-local build-registry container push-manifest

=== vendor/github.com/containerd/continuity/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

PKG=github.com/containerd/continuity

PACKAGES=$(shell go list -mod=vendor ./... | grep -v /vendor/)
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
    for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
        d="$$(dirname $$f)"; \
        [ "$$d" = "." ] && echo "${PKG}" && continue; \
        echo "${PKG}/$$d"; \
    done | sort -u) \
    )

.PHONY: clean all lint build test binaries
.DEFAULT: default

all: AUTHORS clean lint build test binaries

AUTHORS: .mailmap .git/HEAD
	 git log --format='%aN <%aE>' | sort -fu > $@

${PREFIX}/bin/continuity:
	@echo "+ $@"
	@(cd cmd/continuity && go build -mod=mod -o $@  ${GO_GCFLAGS} .)

generate:
	go generate -mod=vendor $(PACKAGES)

lint:
	@echo "+ $@"
	@golangci-lint run

build:
	@echo "+ $@"
	@go build -mod=vendor -v ${GO_LDFLAGS} $(PACKAGES)

test:
	@echo "+ $@"
	@go test -mod=vendor $(PACKAGES)

root-test:
	@echo "+ $@"
	@go test -exec sudo ${TEST_REQUIRES_ROOT_PACKAGES} -test.root

test-compile:
	@echo "+ $@"
	@for pkg in $(PACKAGES); do go test -mod=vendor -c $$pkg; done

binaries: ${PREFIX}/bin/continuity
	@echo "+ $@"
	@if [ x$$GOOS = xwindows ]; then echo "+ continuity -> continuity.exe"; mv ${PREFIX}/bin/continuity ${PREFIX}/bin/continuity.exe; fi

clean:
	@echo "+ $@"
	@rm -rf "${PREFIX}/bin/continuity" "${PREFIX}/bin/continuity.exe"

=== debian/changelog ===
containerd-app (1.7.12-0ubuntu4) noble; urgency=medium

  * Build with Go 1.22.
    - d/control: b-d on golang-1.22-go instead of golang-1.21-go
    - d/rules: add Go 1.22 to $PATH

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 17 Apr 2024 17:01:35 -0300

containerd-app (1.7.12-0ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:39:10 +1100

containerd-app (1.7.12-0ubuntu2) noble; urgency=medium

  * Build with Go 1.21 (LP: #2056154)
    - d/control: b-d on golang-1.21-go instead of golang-1.20-go
    - d/rules: add Go 1.21 to $PATH

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 12 Mar 2024 11:46:44 -0300

containerd-app (1.7.12-0ubuntu1) noble; urgency=medium

  * New upstream release.
  * Build with Go 1.20.
  * d/p/0002-Skip-tests-which-require-a-certain-level-of-privileg.patch:
    refresh.
  * d/containerd.docs: remove NOTICE from vendored runc.
  * d/rules: fix path of the containerd systemd service file.
  * d/rules: do no pass removed commands to dh_golang before dh_gencontrol.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 15 Jan 2024 18:39:58 -0300

containerd-app (1.7.2-0ubuntu2) mantic; urgency=medium

  * Drop patches for -dev packages
    + 0004-disable-windows-support-in-ctr-metric.patch
    + 0005-Revert-Use-insecure.NewCredentials-instead-of-grpc.W.patch
  * Backport patch for Go1.21 (LP: #2032754)
    + 0007-seccomp-apparmor-add-go-noinline.patch

 -- Shengjing Zhu <shengjing.zhu@canonical.com>  Wed, 23 Aug 2023 15:04:29 +0800

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Uploaders: Lucas Kanashiro <kanashiro@ubuntu.com>
+Uploaders: Tianon Gravi <tianon@debian.org>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
                go-md2man,
-               golang-go,
+               golang-1.22-go,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libseccomp-dev,
                pkg-config

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,14 @@
 # https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
 export GO111MODULE := auto
 
+# Build with Golang 1.22
+export PATH := /usr/lib/go-1.22/bin:$(PATH)
+
 execute_before_dh_gencontrol:
 	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
 	DH_GOLANG_BUILDPKG=' \
 		-tags "$(TAGS)" \
 		github.com/containerd/containerd/cmd/containerd \
-		github.com/containerd/containerd/cmd/containerd-shim \
-		github.com/containerd/containerd/cmd/containerd-shim-runc-v1 \
 		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
 		github.com/containerd/containerd/cmd/containerd-stress \
 		github.com/containerd/containerd/cmd/ctr \
@@ -58,9 +59,9 @@
 
 execute_after_dh_installsystemd:
 	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
-	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
-		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
-		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service
+	grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& ! grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service
 
 override_dh_dwz:
 	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"

## containerd-app 1.7.19

=== debian/changelog ===
containerd-app (1.7.19-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport from oracular to jammy. (LP: #2040461)
    - d/rules:
      + fix path of the containerd systemd service file.
      + do not skip pkg/cri/server tests. These were being skipped due to a
        bogus entry in d/patches.
    - d/p/0002-Skip-tests-which-require-a-certain-level-of-privileg.patch:
      drop bogus entry.
    - d/copyright: remove orphan entry from copyright. The entry was added
      back in Lunar due to a vendored runc file copyright (cloned_binary.c).
      That file was later removed from runc but the d/copyright entry for it
      was only partially removed. These changes were not documented in
      d/changelog back then.
    - d/control: remove Uploaders field. It makes little to no sense in Ubuntu
      and this is a Ubuntu specific package.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Fri, 11 Oct 2024 16:30:33 -0300

containerd-app (1.7.19-0ubuntu1) oracular; urgency=medium

  * New upstream release.
  * d/t/basic-smoke: set proxy environment variables.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 03 Jul 2024 18:52:03 -0300

containerd-app (1.7.17-0ubuntu1) oracular; urgency=medium

  * New upstream release.
    - Update AppArmor template to allow confined runc to kill containers
      (LP: #2065423).
  * Refresh patches.
    - d/p/{0006-Skip-test-setting-OOM-score-to-negative-number-in-un,
      0007-seccomp-apparmor-add-go-noinline}.patch: removed, applied by
      upstream.
  * d/rules: skip cri server tests.
  * d/rules: fix path of containerd commands.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 04 Jun 2024 17:24:22 -0300

=== debian/rules ===
--- 
+++ 
@@ -21,10 +21,10 @@
 	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
 	DH_GOLANG_BUILDPKG=' \
 		-tags "$(TAGS)" \
-		github.com/containerd/containerd/cmd/containerd \
-		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
-		github.com/containerd/containerd/cmd/containerd-stress \
-		github.com/containerd/containerd/cmd/ctr \
+		github.com/containerd/containerd/v2/cmd/containerd \
+		github.com/containerd/containerd/v2/cmd/containerd-shim-runc-v2 \
+		github.com/containerd/containerd/v2/cmd/containerd-stress \
+		github.com/containerd/containerd/v2/cmd/ctr \
 	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
 
 override_dh_auto_configure:
@@ -47,7 +47,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
-	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
+	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test
 endif
 endif
 
@@ -59,9 +59,9 @@
 
 execute_after_dh_installsystemd:
 	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
-	grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service \
-		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/containerd/usr/lib/systemd/system/containerd.service \
-		&& ! grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service
+	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
+		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
+		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service
 
 override_dh_dwz:
 	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"

## containerd-app 1.7.19+really1.7.12

=== debian/changelog ===
containerd-app (1.7.19+really1.7.12-0ubuntu4.2) noble; urgency=medium

  * Allow confined runc to kill containers. (LP: #2065423)
    - d/p/Apparmor-allow-kill.patch: Update AppArmor template to allow
      confined runc to kill containers.
    - d/containerd.postinst: notify that a reboot is required to reload the
      AppArmor profile.
  * d/rules: hardcode upstream version to reflect the "really" version in the
    debian revision string. (LP: #2089704)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 28 Nov 2024 09:37:09 -0300

containerd-app (1.7.12-0ubuntu4.1) noble-proposed; urgency=medium

  * SRU: LP: #2076340: No-change rebuild to pick up changed build flags
    on ppc64 and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Aug 2024 04:33:22 +0200

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,10 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export VERSION := $(DEB_VERSION_UPSTREAM)
+# Let's hardcode upstream version to reflect the "really" version in the debian
+# revision string (see LP: #2089704). Please, revert this back to
+# DEB_VERSION_UPSTREAM when upgrading to containerd-app >= 1.7.19
+export VERSION := 1.7.12
 
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 OUR_GOPATH := $(CURDIR)/.gopath
@@ -21,10 +24,10 @@
 	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
 	DH_GOLANG_BUILDPKG=' \
 		-tags "$(TAGS)" \
-		github.com/containerd/containerd/v2/cmd/containerd \
-		github.com/containerd/containerd/v2/cmd/containerd-shim-runc-v2 \
-		github.com/containerd/containerd/v2/cmd/containerd-stress \
-		github.com/containerd/containerd/v2/cmd/ctr \
+		github.com/containerd/containerd/cmd/containerd \
+		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
+		github.com/containerd/containerd/cmd/containerd-stress \
+		github.com/containerd/containerd/cmd/ctr \
 	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
 
 override_dh_auto_configure:
@@ -47,7 +50,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
-	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test
+	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
 endif
 endif
 
@@ -59,9 +62,9 @@
 
 execute_after_dh_installsystemd:
 	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
-	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
-		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
-		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service
+	grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& ! grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service
 
 override_dh_dwz:
 	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
